/* ImageHandler.c generated by valac 0.54.8, the Vala compiler
 * generated from ImageHandler.vala, do not modify */

/*
* Copyright (c) 2017 Felipe Escoto (https://github.com/Philip-Scott/Spice-up)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
* Authored by: Felipe Escoto <felescoto95@hotmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define SPICE_IMAGE_HANDLER_FILENAME "/spice-up-%s-img-%u.%s"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SPICE_TYPE_IMAGE_HANDLER (spice_image_handler_get_type ())
#define SPICE_IMAGE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_IMAGE_HANDLER, SpiceImageHandler))
#define SPICE_IMAGE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_IMAGE_HANDLER, SpiceImageHandlerClass))
#define SPICE_IS_IMAGE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_IMAGE_HANDLER))
#define SPICE_IS_IMAGE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_IMAGE_HANDLER))
#define SPICE_IMAGE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_IMAGE_HANDLER, SpiceImageHandlerClass))

typedef struct _SpiceImageHandler SpiceImageHandler;
typedef struct _SpiceImageHandlerClass SpiceImageHandlerClass;
typedef struct _SpiceImageHandlerPrivate SpiceImageHandlerPrivate;
enum  {
	SPICE_IMAGE_HANDLER_0_PROPERTY,
	SPICE_IMAGE_HANDLER_IMAGE_EXTENSION_PROPERTY,
	SPICE_IMAGE_HANDLER_URL_PROPERTY,
	SPICE_IMAGE_HANDLER_NUM_PROPERTIES
};
static GParamSpec* spice_image_handler_properties[SPICE_IMAGE_HANDLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SPICE_IMAGE_HANDLER_FILE_CHANGED_SIGNAL,
	SPICE_IMAGE_HANDLER_NUM_SIGNALS
};
static guint spice_image_handler_signals[SPICE_IMAGE_HANDLER_NUM_SIGNALS] = {0};

struct _SpiceImageHandler {
	GObject parent_instance;
	SpiceImageHandlerPrivate * priv;
	gboolean valid;
};

struct _SpiceImageHandlerClass {
	GObjectClass parent_class;
};

struct _SpiceImageHandlerPrivate {
	guint file_id;
	GFileMonitor* monitor;
	gboolean file_changing;
	gchar* base64_image;
	gchar* _image_extension;
	gchar* url_;
};

struct _Block6Data {
	int _ref_count_;
	SpiceImageHandler* self;
	GFile* file;
};

static gint SpiceImageHandler_private_offset;
static gpointer spice_image_handler_parent_class = NULL;
VALA_EXTERN guint spice_image_handler_FILE_ID;
guint spice_image_handler_FILE_ID = (guint) 0;

VALA_EXTERN GType spice_image_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SpiceImageHandler, g_object_unref)
VALA_EXTERN SpiceImageHandler* spice_image_handler_new_from_data (const gchar* _extension,
                                                      const gchar* _base64_data);
VALA_EXTERN SpiceImageHandler* spice_image_handler_construct_from_data (GType object_type,
                                                            const gchar* _extension,
                                                            const gchar* _base64_data);
static void spice_image_handler_set_image_extension (SpiceImageHandler* self,
                                              const gchar* value);
static gchar* spice_image_handler_data_to_file (SpiceImageHandler* self,
                                         const gchar* data);
VALA_EXTERN void spice_image_handler_set_url (SpiceImageHandler* self,
                                  const gchar* value);
VALA_EXTERN SpiceImageHandler* spice_image_handler_new_from_file (GFile* file);
VALA_EXTERN SpiceImageHandler* spice_image_handler_construct_from_file (GType object_type,
                                                            GFile* file);
VALA_EXTERN void spice_image_handler_replace (SpiceImageHandler* self,
                                  GFile* file);
static gchar* spice_image_handler_get_extension (SpiceImageHandler* self,
                                          const gchar* filename);
static void spice_image_handler_data_from_file (SpiceImageHandler* self,
                                         GFile* file);
VALA_EXTERN gchar* spice_image_handler_serialize (SpiceImageHandler* self);
VALA_EXTERN const gchar* spice_image_handler_get_image_extension (SpiceImageHandler* self);
static void spice_image_handler_monitor_file (SpiceImageHandler* self,
                                       GFile* file);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda14_ (Block6Data* _data6_,
                   GFile* src,
                   GFile* dest,
                   GFileMonitorEvent event);
static void ____lambda14__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
VALA_EXTERN gchar* spice_services_file_manager_file_to_base64 (GFile* file);
VALA_EXTERN void spice_services_file_manager_base64_to_file (const gchar* filename,
                                                 const gchar* base64_data);
VALA_EXTERN SpiceImageHandler* spice_image_handler_new (void);
VALA_EXTERN SpiceImageHandler* spice_image_handler_construct (GType object_type);
VALA_EXTERN const gchar* spice_image_handler_get_url (SpiceImageHandler* self);
VALA_EXTERN gboolean spice_utils_is_valid_image (GFile* file);
static void spice_image_handler_finalize (GObject * obj);
static GType spice_image_handler_get_type_once (void);
static void _vala_spice_image_handler_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_spice_image_handler_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
spice_image_handler_get_instance_private (SpiceImageHandler* self)
{
	return G_STRUCT_MEMBER_P (self, SpiceImageHandler_private_offset);
}

SpiceImageHandler*
spice_image_handler_construct_from_data (GType object_type,
                                         const gchar* _extension,
                                         const gchar* _base64_data)
{
	SpiceImageHandler * self = NULL;
	guint _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (_extension != NULL, NULL);
	g_return_val_if_fail (_base64_data != NULL, NULL);
	self = (SpiceImageHandler*) g_object_new (object_type, NULL);
	_tmp0_ = spice_image_handler_FILE_ID;
	spice_image_handler_FILE_ID = _tmp0_ + 1;
	self->priv->file_id = _tmp0_;
	if (g_strcmp0 (_extension, "") != 0) {
		_tmp1_ = _extension;
	} else {
		_tmp1_ = "png";
	}
	spice_image_handler_set_image_extension (self, _tmp1_);
	_tmp2_ = g_strdup (_base64_data);
	_g_free0 (self->priv->base64_image);
	self->priv->base64_image = _tmp2_;
	_tmp3_ = spice_image_handler_data_to_file (self, _base64_data);
	_tmp4_ = _tmp3_;
	spice_image_handler_set_url (self, _tmp4_);
	_g_free0 (_tmp4_);
	return self;
}

SpiceImageHandler*
spice_image_handler_new_from_data (const gchar* _extension,
                                   const gchar* _base64_data)
{
	return spice_image_handler_construct_from_data (SPICE_TYPE_IMAGE_HANDLER, _extension, _base64_data);
}

SpiceImageHandler*
spice_image_handler_construct_from_file (GType object_type,
                                         GFile* file)
{
	SpiceImageHandler * self = NULL;
	guint _tmp0_;
	g_return_val_if_fail (file != NULL, NULL);
	self = (SpiceImageHandler*) g_object_new (object_type, NULL);
	_tmp0_ = spice_image_handler_FILE_ID;
	spice_image_handler_FILE_ID = _tmp0_ + 1;
	self->priv->file_id = _tmp0_;
	spice_image_handler_replace (self, file);
	return self;
}

SpiceImageHandler*
spice_image_handler_new_from_file (GFile* file)
{
	return spice_image_handler_construct_from_file (SPICE_TYPE_IMAGE_HANDLER, file);
}

void
spice_image_handler_replace (SpiceImageHandler* self,
                             GFile* file)
{
	GFileMonitor* _tmp0_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = self->priv->monitor;
	if (_tmp0_ != NULL) {
		GFileMonitor* _tmp1_;
		_tmp1_ = self->priv->monitor;
		g_file_monitor_cancel (_tmp1_);
	}
	_tmp2_ = g_file_get_basename (file);
	_tmp3_ = _tmp2_;
	_tmp4_ = spice_image_handler_get_extension (self, _tmp3_);
	_tmp5_ = _tmp4_;
	spice_image_handler_set_image_extension (self, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	spice_image_handler_data_from_file (self, file);
	_tmp6_ = self->priv->base64_image;
	_tmp7_ = spice_image_handler_data_to_file (self, _tmp6_);
	_tmp8_ = _tmp7_;
	spice_image_handler_set_url (self, _tmp8_);
	_g_free0 (_tmp8_);
}

gchar*
spice_image_handler_serialize (SpiceImageHandler* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image_extension;
	_tmp1_ = self->priv->base64_image;
	_tmp2_ = g_strdup_printf ("\"image\":\"%s\", \"image-data\":\"%s\" ", _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		SpiceImageHandler* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->file);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
___lambda14_ (Block6Data* _data6_,
              GFile* src,
              GFile* dest,
              GFileMonitorEvent event)
{
	SpiceImageHandler* self;
	self = _data6_->self;
	g_return_if_fail (src != NULL);
	if (event == G_FILE_MONITOR_EVENT_CHANGED) {
		self->priv->file_changing = TRUE;
	} else {
		gboolean _tmp0_ = FALSE;
		if (event == G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT) {
			_tmp0_ = self->priv->file_changing;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			spice_image_handler_data_from_file (self, _data6_->file);
			g_signal_emit (self, spice_image_handler_signals[SPICE_IMAGE_HANDLER_FILE_CHANGED_SIGNAL], 0);
			self->priv->file_changing = FALSE;
		}
	}
}

static void
____lambda14__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
	___lambda14_ (self, file, other_file, event_type);
}

static void
spice_image_handler_monitor_file (SpiceImageHandler* self,
                                  GFile* file)
{
	Block6Data* _data6_;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (_data6_->file);
	_data6_->file = _tmp0_;
	{
		GFileMonitor* _tmp1_ = NULL;
		GFileMonitor* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		_tmp2_ = g_file_monitor (_data6_->file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (self->priv->monitor);
		self->priv->monitor = _tmp3_;
		_tmp4_ = self->priv->monitor;
		g_signal_connect_data (_tmp4_, "changed", (GCallback) ____lambda14__g_file_monitor_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("ImageHandler.vala:92: Could not monitor file: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		block6_data_unref (_data6_);
		_data6_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	block6_data_unref (_data6_);
	_data6_ = NULL;
}

static gchar*
spice_image_handler_get_extension (SpiceImageHandler* self,
                                   const gchar* filename)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit (filename, ".", 0);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = parts;
	_tmp2__length1 = parts_length1;
	if (_tmp2__length1 > 1) {
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp3_ = parts;
		_tmp3__length1 = parts_length1;
		_tmp4_ = parts;
		_tmp4__length1 = parts_length1;
		_tmp5_ = _tmp3_[_tmp4__length1 - 1];
		_tmp6_ = g_strdup (_tmp5_);
		result = _tmp6_;
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		gchar* _tmp7_;
		_tmp7_ = g_strdup ("png");
		result = _tmp7_;
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
}

static void
spice_image_handler_data_from_file (SpiceImageHandler* self,
                                    GFile* file)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = spice_services_file_manager_file_to_base64 (file);
	_g_free0 (self->priv->base64_image);
	self->priv->base64_image = _tmp0_;
}

static gchar*
spice_image_handler_data_to_file (SpiceImageHandler* self,
                                  const gchar* data)
{
	gchar* filename = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = g_get_tmp_dir ();
	_tmp1_ = g_get_user_name ();
	_tmp2_ = self->priv->_image_extension;
	_tmp3_ = g_strdup_printf (SPICE_IMAGE_HANDLER_FILENAME, _tmp1_, self->priv->file_id, _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp0_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	filename = _tmp6_;
	spice_services_file_manager_base64_to_file (filename, data);
	result = filename;
	return result;
}

SpiceImageHandler*
spice_image_handler_construct (GType object_type)
{
	SpiceImageHandler * self = NULL;
	self = (SpiceImageHandler*) g_object_new (object_type, NULL);
	return self;
}

SpiceImageHandler*
spice_image_handler_new (void)
{
	return spice_image_handler_construct (SPICE_TYPE_IMAGE_HANDLER);
}

const gchar*
spice_image_handler_get_image_extension (SpiceImageHandler* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image_extension;
	result = _tmp0_;
	return result;
}

static void
spice_image_handler_set_image_extension (SpiceImageHandler* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = spice_image_handler_get_image_extension (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_image_extension);
		self->priv->_image_extension = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spice_image_handler_properties[SPICE_IMAGE_HANDLER_IMAGE_EXTENSION_PROPERTY]);
	}
}

const gchar*
spice_image_handler_get_url (SpiceImageHandler* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->url_;
	result = _tmp0_;
	return result;
}

void
spice_image_handler_set_url (SpiceImageHandler* self,
                             const gchar* value)
{
	gchar* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->url_);
	self->priv->url_ = _tmp0_;
	_tmp1_ = g_file_new_for_path (value);
	file = _tmp1_;
	_tmp2_ = file;
	spice_image_handler_monitor_file (self, _tmp2_);
	_tmp4_ = file;
	if (g_file_query_exists (_tmp4_, NULL)) {
		GFile* _tmp5_;
		_tmp5_ = file;
		_tmp3_ = spice_utils_is_valid_image (_tmp5_);
	} else {
		_tmp3_ = FALSE;
	}
	self->valid = _tmp3_;
	g_signal_emit (self, spice_image_handler_signals[SPICE_IMAGE_HANDLER_FILE_CHANGED_SIGNAL], 0);
	_g_object_unref0 (file);
	g_object_notify_by_pspec ((GObject *) self, spice_image_handler_properties[SPICE_IMAGE_HANDLER_URL_PROPERTY]);
}

static void
spice_image_handler_class_init (SpiceImageHandlerClass * klass,
                                gpointer klass_data)
{
	spice_image_handler_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SpiceImageHandler_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_spice_image_handler_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_spice_image_handler_set_property;
	G_OBJECT_CLASS (klass)->finalize = spice_image_handler_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPICE_IMAGE_HANDLER_IMAGE_EXTENSION_PROPERTY, spice_image_handler_properties[SPICE_IMAGE_HANDLER_IMAGE_EXTENSION_PROPERTY] = g_param_spec_string ("image-extension", "image-extension", "image-extension", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPICE_IMAGE_HANDLER_URL_PROPERTY, spice_image_handler_properties[SPICE_IMAGE_HANDLER_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	spice_image_handler_signals[SPICE_IMAGE_HANDLER_FILE_CHANGED_SIGNAL] = g_signal_new ("file-changed", SPICE_TYPE_IMAGE_HANDLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
spice_image_handler_instance_init (SpiceImageHandler * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	self->priv = spice_image_handler_get_instance_private (self);
	self->priv->monitor = NULL;
	self->priv->file_changing = FALSE;
	self->valid = FALSE;
	self->priv->base64_image = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->url_ = _tmp0_;
}

static void
spice_image_handler_finalize (GObject * obj)
{
	SpiceImageHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SPICE_TYPE_IMAGE_HANDLER, SpiceImageHandler);
	_g_object_unref0 (self->priv->monitor);
	_g_free0 (self->priv->base64_image);
	_g_free0 (self->priv->_image_extension);
	_g_free0 (self->priv->url_);
	G_OBJECT_CLASS (spice_image_handler_parent_class)->finalize (obj);
}

static GType
spice_image_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpiceImageHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spice_image_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SpiceImageHandler), 0, (GInstanceInitFunc) spice_image_handler_instance_init, NULL };
	GType spice_image_handler_type_id;
	spice_image_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "SpiceImageHandler", &g_define_type_info, 0);
	SpiceImageHandler_private_offset = g_type_add_instance_private (spice_image_handler_type_id, sizeof (SpiceImageHandlerPrivate));
	return spice_image_handler_type_id;
}

GType
spice_image_handler_get_type (void)
{
	static volatile gsize spice_image_handler_type_id__volatile = 0;
	if (g_once_init_enter (&spice_image_handler_type_id__volatile)) {
		GType spice_image_handler_type_id;
		spice_image_handler_type_id = spice_image_handler_get_type_once ();
		g_once_init_leave (&spice_image_handler_type_id__volatile, spice_image_handler_type_id);
	}
	return spice_image_handler_type_id__volatile;
}

static void
_vala_spice_image_handler_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SpiceImageHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPICE_TYPE_IMAGE_HANDLER, SpiceImageHandler);
	switch (property_id) {
		case SPICE_IMAGE_HANDLER_IMAGE_EXTENSION_PROPERTY:
		g_value_set_string (value, spice_image_handler_get_image_extension (self));
		break;
		case SPICE_IMAGE_HANDLER_URL_PROPERTY:
		g_value_set_string (value, spice_image_handler_get_url (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_spice_image_handler_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SpiceImageHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPICE_TYPE_IMAGE_HANDLER, SpiceImageHandler);
	switch (property_id) {
		case SPICE_IMAGE_HANDLER_IMAGE_EXTENSION_PROPERTY:
		spice_image_handler_set_image_extension (self, g_value_get_string (value));
		break;
		case SPICE_IMAGE_HANDLER_URL_PROPERTY:
		spice_image_handler_set_url (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

